<template>
  <div class="flex flex-col h-full">
    <PageHeader
      :loading="isLoading"
      @refresh="onPageRefresh"
    />

    <Viewport>
      <section>
        <MonthlyStats
          v-if="!isRefreshing"
          @loading:start="isLoading = true"
          @loading:end="isLoading = false"
        />
      </section>

      <section class="mt-6">
        <YearlyStats
          v-if="!isRefreshing"
          @loading:start="isLoading = true"
          @loading:end="isLoading = false"
        />
      </section>
    </Viewport>
  </div>
</template>

<script setup lang="ts">
import { ref } from 'vue';

import Viewport from '@/components/layout/Viewport.vue';
import PageHeader from '@/components/layout/PageHeader.vue';

import MonthlyStats from './MonthlyStats.vue';
import YearlyStats from './YearlyStats.vue';

const isLoading = ref(false);
const isRefreshing = ref(false);

/**
 * On refresh button click we're forcing
 * stats components to be remounted
 */
const onPageRefresh = () => {
  isRefreshing.value = true;

  setTimeout(() => {
    isRefreshing.value = false;
  }, 0);
};
</script>